routes/web.php
<?php

use App\Http\Controllers\HistorialeController;
use App\Http\Controllers\ResidenteController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Auth::routes();

Route::get('/home', 'App\Http\Controllers\HomeController@index')->name('home');

Route::group(['middleware' => 'auth'], function () {
	Route::resource('user', 'App\Http\Controllers\UserController', ['except' => ['show']]);
	Route::get('profile', ['as' => 'profile.edit', 'uses' => 'App\Http\Controllers\ProfileController@edit']);
	Route::put('profile', ['as' => 'profile.update', 'uses' => 'App\Http\Controllers\ProfileController@update']);
	Route::get('upgrade', function () {return view('pages.upgrade');})->name('upgrade'); 
	Route::get('map', function () {return view('pages.maps');})->name('map');
	Route::get('icons', function () {return view('pages.icons');})->name('icons');

	Route::resource('/residentes', 'App\Http\Controllers\ResidenteController');
	Route::resource('/empleados', 'App\Http\Controllers\EmpleadoController');
	Route::get('/residentes/{residente}/pdf', [App\Http\Controllers\ResidenteController::class,'getPdfSignosVitales']);
	Route::get('/residentes/{residente}/hijos/create', function ($residente_id) {return view('hijos.create');});
	Route::resource('/hijos', 'App\Http\Controllers\HijoController');
	Route::resource('/medicinas', 'App\Http\Controllers\MedicinaController');
	Route::resource('/tratamientos', 'App\Http\Controllers\TratamientoController');
	Route::get('/tratamientos/{id}/create', [\App\Http\Controllers\TratamientoController::class, 'create'])->name('tratamientos.create');
	Route::resource('/libroIngresos', 'App\Http\Controllers\LibroIngresoController');
	Route::resource('/libroEgresos', 'App\Http\Controllers\LibroEgresoController');
	Route::resource('/libroGastos', 'App\Http\Controllers\LibroGastoController');
	Route::resource('/dietas', 'App\Http\Controllers\DietaController');
	Route::get('/dietas/{id}/create', [\App\Http\Controllers\DietaController::class, 'create'])->name('dietas.create');

	Route::get('table-list', function () {return view('pages.tables');})->name('table');
	Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'App\Http\Controllers\ProfileController@password']);

	//libro Ingresos
	Route::resource('/libroIngresos', 'App\Http\Controllers\LibroIngresoController');
	//libro Egresos
	Route::resource('/libroEgresos', 'App\Http\Controllers\LibroEgresoController');
	//historiales
	Route::resource('/residentes/{residente}/historiales', 'App\Http\Controllers\HistorialeController');

	Route::delete('/historiales/{id}', [\App\Http\Controllers\HistorialeController::class, 'destroye'])->name('historiales.destroye'); // Laravel 8
	Route::get('/historiales/{id}/edite', [\App\Http\Controllers\HistorialeController::class, 'edite'])->name('historiales.edite'); // Laravel 8
	Route::put('/historiales/{id}', [\App\Http\Controllers\HistorialeController::class, 'updates'])->name('historiales.updates');
	
	//infromes 
	Route::get('/informes', [App\Http\Controllers\InformeController::class,'index'])->name('informes.index');

	Route::post('/informes/pdfIngresosFecha', [App\Http\Controllers\InformeController::class,'pdfIngresosFecha'])->name('informes.pdfIngresosFecha');

	Route::post('/informes/pdfGastosResidente', [App\Http\Controllers\InformeController::class,'pdfGastosResidente'])->name('informes.pdfGastosResidente');

	Route::get('/informes/pdfIngresos', [App\Http\Controllers\InformeController::class,'pdfIngresos']);
	
	Route::get('/informes/pdfEgresos', [App\Http\Controllers\InformeController::class,'pdfEgresos']);
	Route::get('/informes/pdfTotal', [App\Http\Controllers\InformeController::class,'pdfTotal']);
	
});

app/Models/Tratamiento.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Tratamiento extends Model
{
    use HasFactory;
    //Relación uno a muchos(inverso)
    public function historiale(){
        return $this->belongsTo('App\Models\Historiale');
    }
    //Relación uno a muchos(inverso)
     public function medicina(){
        return $this->belongsTo('App\Models\Medicina');
    }
    //Relación uno a muchos(inverso)
    public function empleado()
    {
        return $this->belongsTo('App\Models\Empleado');
    }
}

app/Http/Controllers/TratamientoController.php
<?php

namespace App\Http\Controllers;

use App\Models\Tratamiento;
use App\Models\Medicina;
use App\Models\Empleado;
use App\Models\Residente;
use Illuminate\Http\Request;
use DateTime;

class TratamientoController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $tratamientos=Tratamiento::all();
        //return view('tratamientos.index', compact('tratamientos'));
        return redirect('/home');
    }

    /**
     * Show the form for creating a new resource.
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    // Recibe el id del historial
    public function create($id)
    {
        $residente = Residente::join('historiales', 'historiales.residente_id', '=', 'residentes.id')
                ->where('historiales.id', $id)
                ->select('residentes.*')->get()->first();
        $medicinas=Medicina::all();
        $empleados=Empleado::all();
        return view('tratamientos.create', compact('medicinas'))->with(compact('empleados'))->with(compact('id'))->with(compact('residente'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $validated = $request->validate([
            'descripcion' => 'required|string',
            'fecha' => 'required|date',
            'dosis' => 'required|max:20'
        ]);

        $tratamientos = new Tratamiento();

        $tratamientos->descripcion = $request->get('descripcion');
        $tratamientos->hora = $request->get('hora');
        $tratamientos->fecha = $request->get('fecha');
        $tratamientos->dosis = $request->get('dosis');
        $tratamientos->historial_id = $request->get('historial_id');
        //$tratamientos->historial_id = 1;
        $tratamientos->empleado_id = $request->get('empleado_id');
        $tratamientos->medicina_id = $request->get('medicina_id');

        $tratamientos->save();

        $residente = Residente::join('historiales', 'historiales.residente_id', '=', 'residentes.id')
            ->join('tratamientos', 'tratamientos.historial_id', '=', 'historiales.id')
                    ->where('tratamientos.id', $tratamientos->id)
                    ->select('residentes.*')->get()->first();

        return redirect('/tratamientos/'.$residente->id);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    // recibe el id del residente
    public function show($id)
    {
        $residente = Residente::find($id);
        $tratamientos = Tratamiento::join('historiales', 'historiales.id', '=', 'tratamientos.historial_id')
            ->join('residentes', 'residentes.id', '=', 'historiales.residente_id')
                    ->where('residentes.id', $id)
                    ->select('tratamientos.*')->get();
        $medicina = Tratamiento::join('medicinas', 'medicinas.id', '=', 'tratamientos.medicina_id')
                ->where('tratamientos.id', $tratamientos->first()->id)
                ->select('medicinas.*')->get()->first();
        $fecha = new DateTime($residente->fecha_nacimiento);
        $hoy = new DateTime();
        $dif = $hoy->diff($fecha);
        $edad = $dif->y;
        return view('tratamientos.show', compact('tratamientos'))->with(compact('residente'))->with(compact('medicina'))->with(compact('edad'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Tratamiento  $tratamiento
     * @return \Illuminate\Http\Response
     */
    public function edit(Tratamiento $tratamiento)
    {
        $medicinas=Medicina::all();
        $empleados=Empleado::all();
        $residente = Residente::join('historiales', 'historiales.residente_id', '=', 'residentes.id')
            ->join('tratamientos', 'tratamientos.historial_id', '=', 'historiales.id')
                    ->where('tratamientos.id', $tratamiento->id)
                    ->select('residentes.*')->get()->first();
        return view('tratamientos.edit', compact('tratamiento'))->with(compact('medicinas'))->with(compact('empleados'))->with(compact('residente'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Tratamiento  $tratamiento
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Tratamiento $tratamiento)
    {
        //dd($tratamiento->empleado_id);
        $validated = $request->validate([
            'descripcion' => 'required|string',
            'fecha' => 'required|date',
            'dosis' => 'required|max:20',
        ]);

        $tratamiento->descripcion = $request->get('descripcion');
        $tratamiento->hora = $request->get('hora');
        $tratamiento->fecha = $request->get('fecha');
        $tratamiento->dosis = $request->get('dosis');
        $tratamiento->historial_id = $request->get('historial_id');
        $tratamiento->empleado_id = $request->get('empleado_id');
        $tratamiento->medicina_id = $request->get('medicina_id');

        $tratamiento->save();

        $residente = Residente::join('historiales', 'historiales.residente_id', '=', 'residentes.id')
            ->join('tratamientos', 'tratamientos.historial_id', '=', 'historiales.id')
                    ->where('tratamientos.id', $tratamiento->id)
                    ->select('residentes.*')->get()->first();

        return redirect('tratamientos/'.$residente->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Tratamiento  $tratamiento
     * @return \Illuminate\Http\Response
     */
    public function destroy(Tratamiento $tratamiento)
    {
        $residente = Residente::join('historiales', 'historiales.residente_id', '=', 'residentes.id')
            ->join('tratamientos', 'tratamientos.historial_id', '=', 'historiales.id')
                    ->where('tratamientos.id', $tratamiento->id)
                    ->select('residentes.*')->get()->first();
        $tratamiento->delete();
        return redirect('tratamientos/'.$residente->id);
    }
}

resources/views/tratamientos/create.blade.php
@extends('layouts.app', ['title' => __('Nuevo tratamiento')])

@section('content')
  @include('layouts.headers.header')
  <div class="container-fluid mt--7">
    <div class="card bg-secondary shadow">
      <div class="card-header bg-white border-0">
        <div class="row align-items-center">
          <h3 class="mb-0">{{ __('Nuevo tratamiento') }}</h3>
        </div>
      </div>
      <div class="card-body">
        <form method="post" action="/tratamientos" autocomplete="off">
          @csrf
          <h6 class="heading-small text-muted mb-4">{{ __('Ingresar datos') }}</h6>
                                
          <div class="pl-lg-4">
          <div class="form-group">
              <label class="form-control-label" for="descripcion">{{ __('Descripción') }}</label>
              <input type="text" name="descripcion" id="descripcion" class="form-control" value="{{ old('descripcion') }}" required autofocus>
            </div>
            @if ($errors->has('descripcion'))
              <span class="error text-danger" for="descripcion">{{ $errors->first('descripcion') }}</span>
            @endif
            <div class="form-group row">
              <div class="col">
                <label class="form-control-label" for="fecha">{{ __('Fecha') }}</label>
                <input type="date" name="fecha" id="fecha" class="form-control" value="{{ old('fecha') }}" required>
                @if ($errors->has('fecha'))
                  <span class="error text-danger" for="fecha">{{ $errors->first('fecha') }}</span>
                @endif
              </div>
              <div class="col">
                <label class="form-control-label" for="hora">{{ __('Hora') }}</label>
                <input type="time" name="hora" id="hora" class="form-control" value="{{ old('hora') }}" required>
              </div>
            </div>
            <div class="form-group">
              <label class="form-control-label" for="medicina_id">{{ __('Medicamento') }}</label>
              <select class="form-control select2" id="medicina_id" name="medicina_id">
                <option>-- Seleccionar --</option>
                @foreach($medicinas as $medicina)
                  <option value="{{$medicina->id}}" @if($medicina == old('medicina_id')) selected @endif>{{$medicina->nombre}} ({{$medicina->descripcion}})</option>
                @endforeach
              </select>
            </div>
            @if ($errors->has('medicina_id'))
              <span class="error text-danger" for="medicina_id">{{ $errors->first('medicina_id') }}</span>
            @endif
            <div class="form-group">
              <label class="form-control-label" for="empleado_id">{{ __('Enfermera(o)') }}</label>
              <select class="form-control select2" id="empleado_id" name="empleado_id">
                <option>-- Seleccionar --</option>
                @foreach($empleados as $empleado)
                  <option value="{{$empleado->id}}" @if($empleado == old('empleado_id')) selected @endif>{{$empleado->nombre}} {{$empleado->apellido}}</option>
                @endforeach
              </select>
            </div>
            @if ($errors->has('empleado_id'))
              <span class="error text-danger" for="empleado_id">{{ $errors->first('empleado_id') }}</span>
            @endif
            <div class="form-group">
              <label class="form-control-label" for="dosis">{{ __('Dosis') }}</label>
              <input type="text" name="dosis" id="dosis" class="form-control" value="{{ old('dosis') }}" required>
              <input type="hidden" name="historial_id" value="{{$id}}">
            </div>
            @if ($errors->has('dosis'))
              <span class="error text-danger" for="dosis">{{ $errors->first('dosis') }}</span>
            @endif
            <div class="text-center">
              <a href="../../tratamientos/{{$residente->id}}" class="btn btn-secondary mt-4">{{ __('Cancelar') }}</a>
              <button type="submit" class="btn btn-success mt-4">{{ __('Guardar') }}</button>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
@endsection

@push('js')
    <script src="{{ asset('argon') }}/vendor/chart.js/dist/Chart.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/chart.js/dist/Chart.extension.js"></script>
    <!--  Select2 -->
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/css/select2.min.css" rel="stylesheet"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6-rc.0/js/select2.min.js"></script> 

    <script>
      $(document).ready(function() {
            // Select2 Multiple
            $('.select2').select2({
                placeholder: "Select",
                allowClear: true
            });

      });
    </script> 

@endpush

resources/views/tratamientos/edit.blade.php
@extends('layouts.app', ['title' => __('Editar tratamiento')])

@section('content')
  @include('layouts.headers.header')
  <div class="container-fluid mt--7">
    <div class="card bg-secondary shadow">
      <div class="card-header bg-white border-0">
        <div class="row align-items-center">
          <h3 class="mb-0">{{ __('Editar tratamiento') }}</h3>
        </div>
      </div>
      <div class="card-body">
        <form method="post" action="/tratamientos/{{$tratamiento->id}}" autocomplete="off">
          @csrf
          @method('put')
          <h6 class="heading-small text-muted mb-4">{{ __('Ingresar datos') }}</h6>
                                
          <div class="pl-lg-4">
            <div class="form-group">
              <label class="form-control-label" for="descripcion">{{ __('Descripción') }}</label>
              <input type="text" name="descripcion" id="descripcion" class="form-control" value="{{$tratamiento->descripcion}}" required autofocus>
            </div>
            <div class="form-group">
              <label class="form-control-label" for="hora">{{ __('Hora') }}</label>
              <input type="time" name="hora" id="hora" class="form-control" value="{{$tratamiento->hora}}" required>
            </div>
            <div class="form-group">
              <label class="form-control-label" for="fecha">{{ __('Fecha') }}</label>
              <input type="date" name="fecha" id="fecha" class="form-control" value="{{$tratamiento->fecha}}" required>
            </div>
            <div class="form-group">
              <label class="form-control-label" for="medicina_id">{{ __('Medicamento') }}</label>
              <select class="form-control select2" id="medicina_id" name="medicina_id">
                @foreach($medicinas as $medicina)
                  <option value="{{$medicina->id}}" @if($tratamiento->medicina_id == $medicina->id) selected @endif>{{$medicina->nombre}} ({{$medicina->descripcion}})</option>
                @endforeach
              </select>
            </div>
            <div class="form-group">
              <label class="form-control-label" for="empleado_id">{{ __('Enfermera(o)') }}</label>
              <select class="form-control select2" id="empleado_id" name="empleado_id">
                @foreach($empleados as $empleado)
                  <option value="{{$empleado->id}}" @if($tratamiento->empleado_id == $empleado->id) selected @endif>{{$empleado->nombre}} {{$empleado->apellido}}</option>
                @endforeach
              </select>
            </div>
            <div class="form-group">
              <label class="form-control-label" for="dosis">{{ __('Dosis') }}</label>
              <input type="text" name="dosis" id="dosis" class="form-control" value="{{$tratamiento->dosis}}" required>
            </div>
            <input type="hidden" name="historial_id" value="{{$tratamiento->historial_id}}">
            <div class="text-center">
              <a href="../../tratamientos/{{$residente->id}}" class="btn btn-secondary mt-4">{{ __('Cancelar') }}</a>
              <button type="submit" class="btn btn-success mt-4">{{ __('Guardar') }}</button>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>
@endsection

@push('js')
    <script src="{{ asset('argon') }}/vendor/chart.js/dist/Chart.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/chart.js/dist/Chart.extension.js"></script>
@endpush

resources/views/tratamientos/show.blade.php
@extends('layouts.app')

@section('content')
  @include('layouts.headers.header')
  <!-- Tabla -->
  <div class="container-fluid mt--6">
    <div class="row">
        <div class="col-xl">
                <div class="card card-profile shadow">
                    <div class="row justify-content-center">
                        <div class="col-lg-3 order-lg-2">
                            <div class="card-profile-image">
                                <a href="#">
                                    {{--@if($residente->imagen === null)--}}
                                      <img src="{{ asset('img') }}/residente/img.jpg" class="rounded-circle">
                                    {{--@else
                                      <img src="{{ asset('img') }}/residente/{$residente->imagen}}" class="rounded-circle">
                                    @endif--}}
                                </a>
                            </div>
                        </div>
                    </div>
                    <div class="card-header text-center border-0 pt-8 pt-md-4 pb-0 pb-md-4">
                        <div class="d-flex justify-content-between">
                            <a href="/residentes/{{$residente->id}}/historiales" class="btn btn-sm btn-info mr-4">{{ __('Volver a historial') }}</a>
                            <div class="row mr-4">
                            <a href="../tratamientos/{{$tratamientos->first()->historial_id}}/create" class="btn btn-sm btn-info ">{{ __('Insertar') }}</a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body pt-0 pt-md-4">
                        <div class="row">
                            <div class="col">
                                <div class="card-profile-stats d-flex justify-content-center mt-md-5">
                                    <div>
                                        <span class="description">{{ __('Nombre') }}</span>
                                        <span class="heading">{{$residente->nombre}}</span>
                                    </div>
                                    <div>
                                        <span class="description">{{ __('Apellido') }}</span>
                                        <span class="heading">{{$residente->apellido}}</span>
                                    </div>
                                    <div>
                                        <span class="description">{{ __('Edad') }}</span>
                                        <span class="heading">{{$edad}}</span>
                                    </div>
                                </div>
                            </div>
                        </div>
                        {{--dd($residente, $tratamiento, $medicinas[0])--}}
                        <h1 class="text-center">Tratamientos</h2>
                        @foreach($tratamientos as $tratamiento)
                        <hr />
                        <div>
                          <div class="row mx-5">
                            <div class="col">
                              <h3>Descripción</h3>
                              <p>{{$tratamiento->descripcion}}</p>
                            </div>
                          </div>
                          <div class="row mx-5">
                            <div class="col">
                              <h3>Fecha</h3>
                              <p>{{$tratamiento->fecha}}</p>
                            </div>
                            <div class="col">
                              <h3>Hora</h3>
                              <p>{{$tratamiento->hora}}</p>
                            </div>
                            <div class="col">
                              <h3>Medicación</h3>
                              <p>{{$medicina->nombre}}</p>
                            </div>
                            <div class="col ">
                              <h3>Vía</h3>
                              <p>{{$medicina->via}}</p>
                            </div>
                            <div class="col ">
                              <h3>Dosis</h3>
                              <p>{{$tratamiento->dosis}}</p>
                            </div>
                            <div class="col-1 dropdown">
                              <a class="btn btn-sm btn-icon-only text-light" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <i class="fas fa-ellipsis-v"></i>
                              </a>
                              <div class="dropdown-menu dropdown-menu-right dropdown-menu-arrow">
                                <a href="/tratamientos/{{$tratamiento->id}}/edit" class="dropdown-item">{{ __('Editar') }}</a>
                                <form id="{{$tratamiento->id}}" action="{{route('tratamientos.destroy', $tratamiento->id)}}" method="POST">
                                  @csrf
                                  @method('DELETE')
                                  <a class="dropdown-item" href="javascript:{}" onclick="document.getElementById('{{$tratamiento->id}}').submit(); return false;">Eliminar</a>
                                </form>
                              </div>
                            </div>
                          </div>
                        </div>
                        @endforeach
                    </div>
                </div>
        </div>
    </div>
  </div>
@endsection

@push('js')
    <script src="{{ asset('argon') }}/vendor/chart.js/dist/Chart.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/chart.js/dist/Chart.extension.js"></script>
@endpush